package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	/**
	 * ...
	 * @author Wade McGillis
	 */
	public class DIGI_Hector extends ResettableEntity
	{
		private var vspeed:Number;
		private var canmove:Boolean;
		public var flip:Boolean;
		private var timer:int;
		
		override public function reset():void
		{
			vspeed = 0;
			canmove = true;
			flip = true;
			doTheFlip();
			timer = 0;
		}
		
		public function DIGI_Hector(xx:int,yy:int) 
		{
			super(xx, yy);
			type = "hector";
			reset();
		}
		
		public function doTheFlip():void
		{
			flip = !flip;
			var b:Boolean = false;
			if (graphic != null)
				b = (graphic as Spritemap).flipped;
			if (!flip)
			{
				var spm:Spritemap = new Spritemap(Main.IMG_DIGIHECTOR, 48, 64);
				spm.add("stand", [0]);
				spm.add("walk", [0, 2], .25, true);
				graphic = spm;
				setHitbox(22, 52, -13, -12);
				y -= 12;
			}
			else
			{
				var spm:Spritemap = new Spritemap(Main.IMG_DIGIHECTOR_FLIP, 48, 64);
				spm.add("stand", [0]);
				spm.add("walk", [0, 2], .25, true);
				graphic = spm;
				setHitbox(22, 52, -13, 0);
				y += 12;
			}
			spm.visible = true;
			(graphic as Spritemap).flipped = b;
			(graphic as Image).color = 0xFFFFFF;
		}
		
		override public function update():void
		{
			super.update();
			if ((graphic as Image).color == 0xFF0000)
			{
				timer--;
				if (timer < 15)
					(graphic as Image).visible = !(graphic as Image).visible;
				if (timer == 0)
					(FP.world as GameWorld).died();
				return;		
			}
			if (Input.check(Main.KEYLEFT) && canmove)
			{
				(graphic as Spritemap).flipped = false;
				if (!collide("THETERRAINFOOL", x - 8, y))
					x -= 8;
			}
			if (Input.check(Main.KEYRIGHT) && canmove )
			{
				(graphic as Spritemap).flipped = true;
				if (!collide("THETERRAINFOOL", x + 8, y))
					x += 8;
			}
			
			if (collide("checkpoint", x, y))
			{
				if ((collide("checkpoint", x, y) as DIGI_Checkpoint).flip)
				{
					(FP.world as GameWorld).hectorX = collide("checkpoint", x, y).x;
					(FP.world as GameWorld).hectorY = collide("checkpoint", x, y).y;				
				}
				else
				{
					(FP.world as GameWorld).hectorX = collide("checkpoint", x, y).x;
					(FP.world as GameWorld).hectorY = collide("checkpoint", x, y).y - 20;
				}
				(FP.world as GameWorld).hectorFlip = (collide("checkpoint", x, y) as DIGI_Checkpoint).flip;
			}
			
			if (collide("trinket", x, y))
			{
				(FP.world as GameWorld).cluesRemain--;
				(FP.world as GameWorld).messageTimer = FP.assignedFrameRate*1.5;
				FP.world.remove(collide("trinket", x, y));
			}

			
			if (collide("THETERRAINFOOL", x, y + (flip?-1:1)))
			{
				var arr:Array = [];
				collideInto("vapor", x, y + (flip? -1:1), arr);
				if (arr.length)
				{
					trace("hello");
					var e:Entity;
					for each(e in arr)
					{
						(e as DIGI_VaporFloor).vaporize();
					}
				}
			
				if ((Input.check(Main.KEYLEFT) || Input.check(Main.KEYRIGHT)) && canmove)
					(graphic as Spritemap).play("walk");
				else
					(graphic as Spritemap).play("stand");
				if (Input.pressed(Main.KEYJUMP) && canmove )
					doTheFlip();
			}
			else
			{
				(graphic as Spritemap).play("jump");
				if (flip)
					vspeed -= 1;
				else
					vspeed += 1;
			}
			
			if (vspeed > 16)
				vspeed = 16;
			if (vspeed < -16)
				vspeed = -16;
			
			if (collide("portalpad", x, y) && Input.pressed(Main.KEYACTION) && ((FP.world as GameWorld).cluesRemain == 0))
			{
				canmove = false;
				(FP.world as GameWorld).myHector = null;
				(collide("portalpad", x, y) as DIGI_PortalPad).go(this);
			}
			
			var e:Entity = collide("door", x, y);
			if (e)
			{
				//trace("HIT!");
				if (Input.pressed(Main.KEYACTION))
				{
					//trace("UP! "+(e as Door).gotoString);
					FP.world = new TestWorld((e as Door).gotoString, (e as Door).gotoX);
				}
			}
			
			if (collide("THETERRAINFOOL", x, y + vspeed*2))
			{
				if (!flip)
				{
					if (vspeed > 0)
					{
						while (!collide("THETERRAINFOOL", x, y + 1))
							y++;
					}
					else
					{
						while (!collide("THETERRAINFOOL", x, y - 1))
							y--;
					}
					vspeed = 0;
				}
				else
				{
					if (vspeed < 0)
					{
						while (!collide("THETERRAINFOOL", x, y - 1))
							y--;
					}
					else
					{
						while (!collide("THETERRAINFOOL", x, y + 1))
							y++;
					}
					vspeed = 0;
				}
			}
			else
			{
				y += vspeed*2;
			}
			if (collide("spike", x, y) && (graphic as Image).color != 0xFF0000)
			{
				timer = 31;
				(graphic as Image).color = 0xFF0000;
				(graphic as Spritemap).play("stand");
			}			
			if (x+16 < 0)
				x += (FP.world as GameWorld).width();
			if (x+16 >= (FP.world as GameWorld).width())
				x -= (FP.world as GameWorld).width();	
			if (y+26 < 0)
				y += (FP.world as GameWorld).height();
			if (y+26 >= (FP.world as GameWorld).height())
				y -= (FP.world as GameWorld).height();	
		}
		
	}

}