package  
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.geom.Rectangle;
	import flash.utils.ByteArray;
	import net.flashpunk.Engine;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Backdrop;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.masks.Grid;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.World;
	/**
	 * ...
	 * @author Wade McGillis
	 */
	public class GameWorld extends World
	{
		
		public var myHector:Entity;
		private var levelWidth:int;
		
		private var worldwidth:int;
		private var worldheight:int;
		private var g:Grid;
		
		public var hectorX:int;
		public var hectorY:int;
		public var hectorFlip:Boolean;
		
		private var timer:int;
		private var terrainentity:Entity;
		
		private var texto:Text;
		private var textotime:Text;
		private var messageText:Text;
		
		public var cluesRemain:int;
		public var messageTimer:int;
		
		private var canShow:Boolean;
		
		private var xxx:int;
		private var yyy:int;
		
		public function height():int
		{
			return worldheight;
		}
		
		public function width():int
		{
			return worldwidth;
		}
		
		public function reset():void
		{
			timer = FP.assignedFrameRate * 10;
			var e:Entity;
			var entities:Array = [];
			getClass(ResettableEntity,entities);
			for each(e in entities)
			{
				if (e.type != "hector")
					(e as ResettableEntity).reset();
			}
		}
		
		public function died():void
		{
			reset();
			(myHector as DIGI_Hector).reset();
			myHector.x = hectorX-8;
			myHector.y = hectorY;
			if (hectorFlip)
			{
				(myHector as DIGI_Hector).flip = false;
				(myHector as DIGI_Hector).doTheFlip();
				myHector.y -= 12;
			}
			else
				myHector.y -= 12;
		}
		
		public function GameWorld() 
		{
			super();
			canShow = false;
			cluesRemain = 4;
			messageTimer = 0;
			timer = FP.assignedFrameRate * 10;
			
			texto = new Text("HEY", 0, 416, 512, 32);
			texto.color = 0xFFFFFF;
			texto.size *= 2;
			
			var o:Object = new Object;
			o.width = 512;
			o.height = 32;
			o.align = "right";
			textotime = new Text("HEY", 512-80, 416, 512, 32);
			textotime.color = 0xFFFFFF;
			textotime.size *= 2;
			
			var o:Object = new Object;
			o.width = 384-16;
			o.height = 64-16;
			o.align = "center";
			messageText = new Text(""+cluesRemain+" CLUES REMAIN", 64 + 16, 416/2 - 32/2, o);
			messageText.color = 0xFFFFFF;
			messageText.size *= 2;
			
			messageTimer = FP.assignedFrameRate*1.5;
			
			FP.screen.color = 0x000000;
			FP.camera.x = 0;
			FP.camera.y = 0;
			var b:BitmapData = (new Main.IMG_LEVEL).bitmapData;
			var colormap:BitmapData = (new Main.IMG_LEVELCOLORMAP).bitmapData;
			
			worldwidth = 16 * b.width;
			worldheight = 16 * b.height;
			
			g = new Grid(16 * b.width, 16 * b.height, 16, 16, 0, 0);
			var rect:Rectangle = new Rectangle(0, 0, 16, 16);
			for (var i:int = 0; i < b.width; i++)
				for (var j:int = 0; j < b.height; j++)
				{
					var c:uint = b.getPixel(i, j);
					if (c == 0x00FF00 || c == 0x008000)
					{
						g.setTile(i, j, true);
						var cc:uint = colormap.getPixel(i / 32, j / 26);
						if (cc == 0x00FF00)
						{
							rect.x = 0;
							rect.y = 0;
						}
						if (cc == 0x0000FF)
						{
							rect.x = 16;
							rect.y = 0;
						}
						if (cc == 0xFF0000)
						{
							rect.x = 32;
							rect.y = 0;
						}
						(addGraphic(new Image(Main.IMG_DIGIBLOCK, rect), 100, 16 * i, 16 * j).graphic as Image).color = cc;
					}
					if (c == 0x808080)
					{
						
						hectorX = 16 * i;
						hectorY = 16 * j - 36;
						hectorFlip = false;
						myHector = add(new DIGI_Hector(16 * i, 16 * j - 36));
					}
					if (c == 0x808000)
						add(new DIGI_PortalPad(16 * i, 16 * j));
					if (c == 0xC0C0C0 || c == 0xA0A0A0)
						add(new DIGI_Checkpoint(16 * i, 16 * j, c == 0xA0A0A0));
					if (c == 0x8000FF || c == 0x8080FF)
						add(new DIGI_Clue(16 * i, 16 * j, c == 0x8080FF));
					if (c == 0xFF0000)
						add(new DIGI_Spike(16 * i, 16 * j, 0));
					if (c == 0xFF8000)
						add(new DIGI_Spike(16 * i, 16 * j, 1));
					if (c == 0xFF8080)
						add(new DIGI_Spike(16 * i, 16 * j, 2));
					if (c == 0xFFFF00)
						add(new DIGI_Spike(16 * i, 16 * j, 3));
					if (c == 0xFF00FF)
						add(new DIGI_VaporFloor(16 * i, 16 * j));
					if (c == 0xFF006E)
						add(new DIGI_DemonCat(16 * i, 16 * j));
				}
			for (var i:int = 0; i < b.width; i++)
				for (var j:int = 0; j < b.height; j++)
				{
					if (checkTile(i, j))
					{
						// horz and vert
						if (checkTile(i - 1, j) && checkTile(i + 1, j) && !checkTile(i, j - 1)) // top
							(addGraphic(new Image(Main.IMG_DIGIBORDER, new Rectangle(16, 0, 16, 16)), 50, 16 * i, 16 * j).graphic as Image).color = colormap.getPixel(i / 32, j / 26);
						if (checkTile(i - 1, j) && checkTile(i + 1, j) && !checkTile(i, j + 1)) // bottom
							(addGraphic(new Image(Main.IMG_DIGIBORDER, new Rectangle(16, 32, 16, 16)), 50, 16 * i, 16 * j).graphic as Image).color = colormap.getPixel(i / 32, j / 26);
						if (checkTile(i, j - 1) && checkTile(i, j + 1) && !checkTile(i - 1, j)) // left
							(addGraphic(new Image(Main.IMG_DIGIBORDER, new Rectangle(0, 16, 16, 16)), 50, 16 * i, 16 * j).graphic as Image).color = colormap.getPixel(i / 32, j / 26);
						if (checkTile(i, j - 1) && checkTile(i, j + 1) && !checkTile(i + 1, j)) // right
							(addGraphic(new Image(Main.IMG_DIGIBORDER, new Rectangle(32, 16, 16, 16)), 50, 16 * i, 16 * j).graphic as Image).color = colormap.getPixel(i / 32, j / 26);
						// outer corners
						if (!checkTile(i - 1, j) && checkTile(i + 1, j) && !checkTile(i, j - 1) && checkTile(i, j + 1)) // top left
							(addGraphic(new Image(Main.IMG_DIGIBORDER, new Rectangle(0, 0, 16, 16)), 50, 16 * i, 16 * j).graphic as Image).color = colormap.getPixel(i / 32, j / 26);
						if (checkTile(i - 1, j) && !checkTile(i + 1, j) && !checkTile(i, j - 1) && checkTile(i, j + 1)) // top right
							(addGraphic(new Image(Main.IMG_DIGIBORDER, new Rectangle(32, 0, 16, 16)), 50, 16 * i, 16 * j).graphic as Image).color = colormap.getPixel(i / 32, j / 26);
						if (!checkTile(i - 1, j) && checkTile(i + 1, j) && checkTile(i, j - 1) && !checkTile(i, j + 1)) // top left
							(addGraphic(new Image(Main.IMG_DIGIBORDER, new Rectangle(0, 32, 16, 16)), 50, 16 * i, 16 * j).graphic as Image).color = colormap.getPixel(i / 32, j / 26);
						if (checkTile(i - 1, j) && !checkTile(i + 1, j) && checkTile(i, j - 1) && !checkTile(i, j + 1)) // top right
							(addGraphic(new Image(Main.IMG_DIGIBORDER, new Rectangle(32, 32, 16, 16)), 50, 16 * i, 16 * j).graphic as Image).color = colormap.getPixel(i / 32, j / 26);
						// single alone
						if (!checkTile(i - 1, j) && !checkTile(i + 1, j) && !checkTile(i, j - 1) && !checkTile(i, j + 1))
							(addGraphic(new Image(Main.IMG_DIGIBORDER, new Rectangle(48, 32, 16, 16)), 50, 16 * i, 16 * j).graphic as Image).color = colormap.getPixel(i / 32, j / 26);
						// center everything sticks out
						/*if (checkTile(i - 1, j) && checkTile(i + 1, j) && checkTile(i, j - 1) && checkTile(i, j + 1) && 
							!checkTile(i - 1, j - 1) && !checkTile(i - 1, j + 1) && !checkTile(i + 1, j - 1) && !checkTile(i + 1, j + 1))
							{
								(addGraphic(new Image(Main.IMG_DIGIBORDER, new Rectangle(0, 48, 16, 16)), 50, 16 * i, 16 * j).graphic as Image).color = colormap.getPixel(i / 32, j / 26);
								(addGraphic(new Image(Main.IMG_DIGIBORDER, new Rectangle(16, 48, 16, 16)), 50, 16 * i, 16 * j).graphic as Image).color = colormap.getPixel(i / 32, j / 26);
								(addGraphic(new Image(Main.IMG_DIGIBORDER, new Rectangle(32, 48, 16, 16)), 50, 16 * i, 16 * j).graphic as Image).color = colormap.getPixel(i / 32, j / 26);
								(addGraphic(new Image(Main.IMG_DIGIBORDER, new Rectangle(48, 48, 16, 16)), 50, 16 * i, 16 * j).graphic as Image).color = colormap.getPixel(i / 32, j / 26);
							}*/
						// single ends
						if (!checkTile(i - 1, j) && checkTile(i + 1, j) && !checkTile(i, j - 1) && !checkTile(i, j + 1)) // sticks to the left
							(addGraphic(new Image(Main.IMG_DIGIBORDER, new Rectangle(64, 48, 16, 16)), 50, 16 * i, 16 * j).graphic as Image).color = colormap.getPixel(i / 32, j / 26);
						if (checkTile(i - 1, j) && !checkTile(i + 1, j) && !checkTile(i, j - 1) && !checkTile(i, j + 1)) // sticks to the right
							(addGraphic(new Image(Main.IMG_DIGIBORDER, new Rectangle(64, 16, 16, 16)), 50, 16 * i, 16 * j).graphic as Image).color = colormap.getPixel(i / 32, j / 26);
						if (!checkTile(i - 1, j) && !checkTile(i + 1, j) && !checkTile(i, j - 1) && checkTile(i, j + 1)) // sticks up
							(addGraphic(new Image(Main.IMG_DIGIBORDER, new Rectangle(64, 0, 16, 16)), 50, 16 * i, 16 * j).graphic as Image).color = colormap.getPixel(i / 32, j / 26);
						if (!checkTile(i - 1, j) && !checkTile(i + 1, j) && checkTile(i, j - 1) && !checkTile(i, j + 1)) // sticks down
							(addGraphic(new Image(Main.IMG_DIGIBORDER, new Rectangle(64, 32, 16, 16)), 50, 16 * i, 16 * j).graphic as Image).color = colormap.getPixel(i / 32, j / 26);
						// inner corners
						if (checkTile(i, j - 1) && checkTile(i - 1, j) && !checkTile(i - 1, j - 1)) // top left
							(addGraphic(new Image(Main.IMG_DIGIBORDER, new Rectangle(48, 48, 16, 16)), 50, 16 * i, 16 * j).graphic as Image).color = colormap.getPixel(i / 32, j / 26);
						if (checkTile(i, j - 1) && checkTile(i + 1, j) && !checkTile(i + 1, j - 1)) // top right
							(addGraphic(new Image(Main.IMG_DIGIBORDER, new Rectangle(32, 48, 16, 16)), 50, 16 * i, 16 * j).graphic as Image).color = colormap.getPixel(i / 32, j / 26);	
						if (checkTile(i, j + 1) && checkTile(i - 1, j) && !checkTile(i - 1, j + 1)) // bottom left
							(addGraphic(new Image(Main.IMG_DIGIBORDER, new Rectangle(16, 48, 16, 16)), 50, 16 * i, 16 * j).graphic as Image).color = colormap.getPixel(i / 32, j / 26);
						if (checkTile(i, j + 1) && checkTile(i + 1, j) && !checkTile(i + 1, j + 1)) // bottom right
							(addGraphic(new Image(Main.IMG_DIGIBORDER, new Rectangle(0, 48, 16, 16)), 50, 16 * i, 16 * j).graphic as Image).color = colormap.getPixel(i / 32, j / 26);						
			
					}
							
				}

			var img:Image = new Image(g.data);
			img.scale = 16;
			img.color = 0x00FF00;

			terrainentity = add(new Entity(0, 0, null, g));
			terrainentity.type = "THETERRAINFOOL";
			
			xxx = -1000;
			yyy = -1000;
			for (var i:int = 0; i < b.width; i++)
				for (var j:int = 0; j < b.height; j++)
				{
					if (b.getPixel(i, j) == 0x008000)
						setSolid(i, j, false);
				}	
			
		}
		
		private function checkTile(x:int, y:int):Boolean
		{
			if (x < 0)
				x += worldwidth / 16;
			if (x >= worldwidth / 16)
				x -= worldwidth / 16;
			if (y < 0)
				y += worldheight / 16;
			if (y >= worldheight / 16)
				y -= worldheight / 16;
			return g.getTile(x, y);
		}
		
		override public function begin():void
		{
			super.begin();
		}
		
		public function setSolid(x:int, y:int, s:Boolean)
		{
			(terrainentity.mask as Grid).setTile(x, y, s);
		}
		public function getSolid(x:int, y:int)
		{
			return (terrainentity.mask as Grid).getTile(x, y);
		}
		
		override public function update():void
		{
			if (messageTimer > 0 && canShow)
			{
				messageTimer--;
				return;
			}
			timer--;
			var seconds:int = (Math.floor(100 * (timer % FP.assignedFrameRate) / FP.assignedFrameRate) as int);
			textotime.text = "" + (Math.floor(timer / FP.assignedFrameRate) as int) + ":" + (seconds<10?("0"+seconds):(""+seconds));
			textotime.updateTextBuffer();
			textotime.updateBuffer();
			if (timer == 0)
			{
				reset();
			}
			super.update();
			if (messageTimer == FP.assignedFrameRate * 1.5)
			{
				if (cluesRemain == 0)
					messageText.text = "RETURN HOME";
				else
					messageText.text = "" + cluesRemain + " CLUE"+((cluesRemain==1)?"":"S")+" REMAIN"+((cluesRemain==1)?"S":"");
				messageText.updateTextBuffer();
				messageText.updateBuffer();					
			}
			if (myHector != null)
			{
				FP.camera.x = 512 * Math.floor((myHector.x+16) / 512);
				FP.camera.y = 416 * Math.floor((myHector.y+26) / 416);
			}
			if (myHector != null)
			if (Math.floor((myHector.x+16) / 512) != xxx || Math.floor((myHector.y + 26) / 416) != yyy)
			{
				xxx = Math.floor((myHector.x+16) / 512);
				yyy = Math.floor((myHector.y + 26) / 416);
				trace(" x " + xxx + " y " + yyy);
				if (xxx == 0 && yyy === 0)
				{
					texto.text = "MUST BE ALLERGIC";
					texto.updateTextBuffer();
					texto.updateBuffer();
				}
				if (xxx == 1 && yyy === 0)
				{
					texto.text = "UP AND DOWN";
					texto.updateTextBuffer();
					texto.updateBuffer();
				}
				if (xxx == 2 && yyy === 0)
				{
					texto.text = "BEGIN";
					texto.updateTextBuffer();
					texto.updateBuffer();
				}
				if (xxx == 3 && yyy === 0)
				{
					texto.text = "DON'T SUE ME, TERRY";
					texto.updateTextBuffer();
					texto.updateBuffer();
				}
				
				if (xxx == 0 && yyy === 1)
				{
					texto.text = "SOFT KITTY";
					texto.updateTextBuffer();
					texto.updateBuffer();
				}
				if (xxx == 1 && yyy === 1)
				{
					texto.text = "CORRIDOR";
					texto.updateTextBuffer();
					texto.updateBuffer();
				}
				if (xxx == 2 && yyy === 1)
				{
					texto.text = "RETURN";
					texto.updateTextBuffer();
					texto.updateBuffer();
				}
				if (xxx == 3 && yyy === 1)
				{
					texto.text = "HIDE AND SEEK";
					texto.updateTextBuffer();
					texto.updateBuffer();
				}
			}
			
			/*if (FP.camera.x < 0)
				FP.camera.x = 0;
			if (FP.camera.x > levelWidth - FP.screen.width)
				FP.camera.x = levelWidth - FP.screen.width;*/
				canShow = true;
		}
		
		override public function render():void
		{
			var xx = 0;
			var yy = 0;
			if (timer < FP.assignedFrameRate*2)
			{
				var d:int = (FP.assignedFrameRate * 2)-timer;
				xx = -d/2+d*Math.random();
				yy = -d/2+d*Math.random();
			}
			FP.camera.x += xx;
			FP.camera.y += yy;
			super.render();
			
			if (messageTimer > 0 && canShow)
			{
				Draw.rect(FP.camera.x + 64, FP.camera.y + 416 / 2 - 64 / 2, 384, 64, 0xA0A0A0);
				Draw.rect(FP.camera.x + 64 + 2, FP.camera.y + 416 / 2 - 64 / 2 + 2, 384 - 4, 64 - 4, 0x000000);
				Draw.rect(FP.camera.x + 64 + 4, FP.camera.y + 416 / 2 - 64 / 2 + 4, 384 - 8, 64 - 8, 0xA0A0A0);
				Draw.rect(FP.camera.x + 64 + 6, FP.camera.y + 416 / 2 - 64 / 2 + 6, 384 - 12, 64 - 12, 0x000000);
				messageText.render(FP.buffer, FP.zero, FP.zero);
				
			}
			
			
			Draw.rect(FP.camera.x, FP.camera.y + 416, 512, 32, 0x000000);
			texto.render(FP.buffer, FP.zero, FP.zero);
			textotime.render(FP.buffer, FP.zero, FP.zero);
			FP.camera.x -= xx;
			FP.camera.y -= yy;
			if (timer < (FP.assignedFrameRate / 2 + 7))
			{
				var a:Number = ((FP.assignedFrameRate / 2 + 7) - (timer as Number)) / (FP.assignedFrameRate / 2);
				trace(""+a);
				Draw.rect(FP.camera.x, FP.camera.y, 512, 416, 0xFFFFFF, a);
			}
		}
		
	}

}