package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	/**
	 * ...
	 * @author Wade McGillis
	 */
	public class Hector extends Entity
	{
		private var vspeed:Number;
		private var canmove:Boolean;
		public function Hector(xx:int,yy:int) 
		{
			super(xx, yy);
			var spm:Spritemap = new Spritemap(Main.IMG_HECTOR, 48, 64);
			spm.add("stand", [0]);
			spm.add("walk", [0, 2], .25, true);
			spm.add("jump", [3]);
			graphic = spm;
			setHitbox(32, 52, -8, -12);
			vspeed = 0;
			canmove = true;
		}
		
		override public function update():void
		{
			super.update();
			if (Input.check(Key.LEFT) && canmove)
			{
				(graphic as Spritemap).flipped = false;
				if (!collide("THETERRAINFOOL", x - 2, y))
					x -= 2;
			}
			if (Input.check(Key.RIGHT) && canmove )
			{
				(graphic as Spritemap).flipped = true;
				if (!collide("THETERRAINFOOL", x + 2, y))
					x += 2;
			}
			if (collide("THETERRAINFOOL", x, y + 1))
			{
				if ((Input.check(Key.LEFT) || Input.check(Key.RIGHT)) && canmove)
					(graphic as Spritemap).play("walk");
				else
					(graphic as Spritemap).play("stand");
				if (Input.check(Key.UP) && canmove )
					vspeed = -10;
			}
			else
			{
				(graphic as Spritemap).play("jump");
				vspeed += .5;
			}
			
			if (collide("portalpad", x, y) && Input.pressed(Key.SPACE))
			{
				canmove = false;
				(FP.world as TestWorld).myHector = null;
				(collide("portalpad", x, y) as PortalPad).go(this);
			}
			
			var e:Entity = collide("door", x, y);
			if (e)
			{
				//trace("HIT!");
				if (Input.pressed(Key.SPACE))
				{
					//trace("UP! "+(e as Door).gotoString);
					FP.world = new TestWorld((e as Door).gotoString, (e as Door).gotoX);
				}
			}
			
			if (collide("THETERRAINFOOL", x, y + vspeed))
			{
				if (vspeed > 0)
					y = 16 * Math.floor((y+vspeed) / 16);
				else
					y = 16 * Math.ceil((y+vspeed) / 16)+4;
				vspeed = 0;
			}
			else
			{
				y += vspeed;
				vspeed += .5;
			}
			
			
			var minDistance:Number = 100000000;
			var entityToTalk:Entity = null;
			var entities:Array = [];
			FP.world.getType("npc", entities);
			for (var i:int = 0; i < entities.length; i++)
			{
				var dd:Number = distanceFrom((entities[i] as Entity), true);
				if (dd < minDistance)
				{
					entityToTalk = entities[i] as Entity;
					minDistance = dd;
				}
			}
			if (entityToTalk != null)
			{
				if (minDistance < 8)//collideWith(entityToTalk,entityToTalk.x,entityToTalk.y)
				{
					//trace("TOOT");
					(entityToTalk as NPC).excite(true);
					if (Input.pressed(Key.SPACE))
					{	
						if ((FP.world as TestWorld).getTalkingEntity() == entityToTalk)
						{
							//trace("We're already the dood, so here's more text!");
							(entityToTalk as NPC).sayMore();
							if ((entityToTalk as NPC).getMessage() != "ENDOFTALKING")
								(FP.world as TestWorld).setText((entityToTalk as NPC).getMessage());
							else
								(FP.world as TestWorld).setText("");
						}
						else
						{
							//trace("First time talking!");
							(FP.world as TestWorld).setTalkingEntity(entityToTalk);
							(FP.world as TestWorld).setText((entityToTalk as NPC).getMessage());
						}
					}
				}
				else // If we are no longer close enough to the closest NPC
				{
					//trace("SHUT THEM UP");
					(entityToTalk as NPC).shutup();
					(entityToTalk as NPC).excite(false);
					(FP.world as TestWorld).setText("");
					(FP.world as TestWorld).setTalkingEntity(null);
				}
			}
			else
				(FP.world as TestWorld).setText("");
		}
		
	}

}