package  
{
	import flash.geom.Rectangle;
	import net.flashpunk.Engine;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.Screen;
	import net.flashpunk.utils.Input;
	import net.flashpunk.World;
	/**
	 * ...
	 * @author Wade McGillis
	 */
	public class HelpScreen extends World
	{
		
		var pos:int = 0;
		var rects:Array = [new Rectangle(278, 175, 124, 45), new Rectangle(278, 220, 124, 45), new Rectangle(278, 265, 284, 183)];
		var xx:Array = [234, 234, 234];
		var yy:Array = [177, 220, 332];
		var cursor:Entity = null;
		
		var mousexprev:int;
		var mouseyprev:int;
		
		public function HelpScreen() 
		{
			super();
		}
		
		override public function begin():void
		{
			super.begin();
			//addGraphic(new Image(Main.IMG_HELPSCREEN));
			cursor = addGraphic(new Image(Main.IMG_CURSOR), 0, xx[pos], yy[pos]);
			mousexprev = -1;
			mouseyprev = -1;
		}
		
		private function mouseInRect(r:Rectangle):Boolean
		{
			if (Input.mouseX >= r.x)
				if (Input.mouseY >= r.y)
					if (Input.mouseX < r.x + r.width)
						if (Input.mouseY < r.y + r.height)
							return true;
			return false;
		}
		
		override public function update():void
		{
			super.update();
			cursor.x = xx[pos];
			cursor.y = yy[pos];
			
			if (Input.pressed(Main.KEYLEFT))
			{
				pos--;
				if (pos < 0)
					pos += 3;
			}
			if (Input.pressed(Main.KEYRIGHT))
			{
				pos++;
				if (pos > 2)
					pos -= 3;
			}
			
			if (Input.mousePressed)
				for (var i:int = 0; i < 3; i++)
					if (mouseInRect(rects[i]))
					{
						if (i == 0)
						{
							FP.width = 256;
							FP.height = 224;
							FP.halfWidth = 256/2;
							FP.halfHeight = 224 / 2;
							FP.screen = new Screen;
							FP.screen.scale = 2;
							FP.bounds = new Rectangle(0, 0, 256, 224);
							FP.world = new TestWorld("town", -1000);
						}
						if (i == 1)
							{
									FP.world = new HelpScreen();
							}
						if (i == 2)
							{}
					}
			
			if (Input.mouseX != mousexprev || Input.mouseY != mouseyprev)
				for (var i:int = 0; i < 3; i++)
					if (mouseInRect(rects[i]))
						pos = i;
			
			mousexprev = Input.mouseX;
			mouseyprev = Input.mouseY;
		}
		
		
		
	}

}