package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	/**
	 * ...
	 * @author Wade McGillis
	 */
	public class NPC extends Entity
	{
		
		protected var sayings:Array;
		protected var current:int;
		private var excited:Boolean;
		private var speechbubble:Entity;
		
		public function NPC(xx:Number, yy:Number, talkings:Array) 
		{
			super(xx, yy);
			sayings = talkings;
			type = "npc";
			current = 0;
			speechbubble = FP.world.addGraphic(new Image(Main.IMG_SPEECH), 0, x + width / 2 - 12, y - 12);
			speechbubble.visible = excited = false;
		}
		
		override public function update():void
		{
			super.update();
			if ((FP.world as TestWorld).getTalkingEntity() != this)
				current = 0;
		}
		
		public function shutup():void
		{
			current = 0;
		}
		
		public function excite(b:Boolean):void
		{
			//trace("HELP");
			//trace("I AM " + (b?"":"NOT") + " EXCITED NOW!");
			speechbubble.visible = b;
		}
		
		public function sayMore():void
		{
			current++;
			//trace("0");
			if (current == sayings.length || sayings[Math.min(current, sayings.length - 1)] == "ENDOFTALKING")
			{
				//trace("1");
				if ((FP.world as TestWorld).getTalkingEntity() == this)
				{
					//trace("2");
					(FP.world as TestWorld).setTalkingEntity(null);
				}
			}
		}
		
		public function getMessage():String
		{
			if (current >= sayings.length)
				return "ENDOFTALKING";
			return sayings[Math.min(current, sayings.length - 1)];
		}
		
	}

}