package  
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.geom.Rectangle;
	import flash.utils.ByteArray;
	import flash.utils.Endian;
	import net.flashpunk.Engine;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Backdrop;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.masks.Grid;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.World;
	/**
	 * ...
	 * @author Wade McGillis
	 */
	public class TestWorld extends World
	{
		
		public var myHector:Entity;
		private var leftDoor:Entity;
		private var rightDoor:Entity;
		private var levelWidth:int;
		private var currentTalking:String;
		private var imgMessageBox:Image;
		private var messageText:Text;
		private var talkingEntity:Entity;
		
		private var levelname:String;
		private var xposition:int;
		
		public function TestWorld(templevelname:String="undefined",tempxposition:int=-1000) 
		{
			super();
			levelname = templevelname;
			xposition = tempxposition;
		}
		override public function begin():void
		{
			super.begin();
			trace("THE LEVEL ID IS --" + levelname + "--");
			var ba:ByteArray = Main.getLevelFromName(levelname);
			
			var xml:XML = new XML(ba);
			
			messageText = new Text("", 0, 0, 256, 64);
			messageText.color = 0xFF000000;
			
			talkingEntity = null;
			
			imgMessageBox = new Image(Main.IMG_MESSAGEBOX);
			
			currentTalking = "";
			
			levelWidth = xml.@width;
			
			var zero:String = "0";
			var pic:int = xml.child("Backgrounds").valueOf().toString().charCodeAt(0) - zero.charCodeAt(0);
			addGraphic(new Backdrop(new Image(Main.IMG_BACKGROUNDS, new Rectangle(256 * ((pic % 2) as int), 224 * ((pic / 2) as int), 256, 224))._buffer, true, true));

			var myGridYo:Grid = new Grid(xml.@width, xml.@height, 16, 16, 0, 0);
			//var s:String = ;
			//for (var i:int = 0; i < xml.@width / 16; i++)
			//	for (var j:int = 0; j < xml.@height / 16; j++)
					myGridYo.loadFromString(xml.child("Solids").valueOf().toString(), "", "\n");
					
					var img:Image = new Image(myGridYo.data);
					img.scale = 16;
			
			
			for each(var tile:XML in xml.child("Tiles").children())
			{
				addGraphic(new Image(Main.IMG_TILES, new Rectangle(16*tile.@tx,16*tile.@ty, 16, 16)),0,16*tile.@x,16*tile.@y);
			}
			add(new Entity(0, 0, null, myGridYo)).type = "THETERRAINFOOL";
			
			for each(var ent:XML in xml.child("Entities").children())
			{
				if (ent.name() == "Hector")
				{
					var xx:int = xposition;
					if (xx == 12345678)
						xx = levelWidth - 64;
					else if (xx == -1000)
						xx = ent.@x;
					myHector = add(new Hector(xx, ent.@y));
				}
				if (ent.name() == "LeftDoor")
					leftDoor = add(new DoorLeft(ent.@x, ent.@y, ent.@GotoName, ent.@GotoX));
				if (ent.name() == "Door")
					add(new Door(ent.@x, ent.@y, ent.@GotoName, ent.@GotoX));
				if (ent.name() == "RightDoor")
					rightDoor = add(new DoorRight(ent.@x, ent.@y, ent.@GotoName, ent.@GotoX));
				if (ent.name() == "PortalPad")
					add(new PortalPad(ent.@x, ent.@y));
				if (ent.name() == "Alien")
					add(new Alien(ent.@x, ent.@y, [
					(ent.@say1.toString() as String).replace("#", "\n").replace("#", "\n").replace("#", "\n"),
					(ent.@say2.toString() as String).replace("#", "\n").replace("#", "\n").replace("#", "\n"),
					(ent.@say3.toString() as String).replace("#", "\n").replace("#", "\n").replace("#", "\n"),
					(ent.@say4.toString() as String).replace("#", "\n").replace("#", "\n").replace("#", "\n"),
					(ent.@say5.toString() as String).replace("#", "\n").replace("#", "\n").replace("#", "\n")
					]));
				if (ent.name() == "Jefe")
					add(new Jefe(ent.@x, ent.@y, [
					(ent.@say1.toString() as String).replace("#", "\n").replace("#", "\n").replace("#", "\n"),
					(ent.@say2.toString() as String).replace("#", "\n").replace("#", "\n").replace("#", "\n"),
					(ent.@say3.toString() as String).replace("#", "\n").replace("#", "\n").replace("#", "\n"),
					(ent.@say4.toString() as String).replace("#", "\n").replace("#", "\n").replace("#", "\n"),
					(ent.@say5.toString() as String).replace("#", "\n").replace("#", "\n").replace("#", "\n")
					]));
				if (ent.name() == "Ese")
					add(new Ese(ent.@x, ent.@y, [
					(ent.@say1.toString() as String).replace("#", "\n").replace("#", "\n").replace("#", "\n"),
					(ent.@say2.toString() as String).replace("#", "\n").replace("#", "\n").replace("#", "\n"),
					(ent.@say3.toString() as String).replace("#", "\n").replace("#", "\n").replace("#", "\n"),
					(ent.@say4.toString() as String).replace("#", "\n").replace("#", "\n").replace("#", "\n"),
					(ent.@say5.toString() as String).replace("#", "\n").replace("#", "\n").replace("#", "\n")
					]));
				if (ent.name() == "Lady")
					add(new Lady(ent.@x, ent.@y, [
					(ent.@say1.toString() as String).replace("#", "\n").replace("#", "\n").replace("#", "\n"),
					(ent.@say2.toString() as String).replace("#", "\n").replace("#", "\n").replace("#", "\n"),
					(ent.@say3.toString() as String).replace("#", "\n").replace("#", "\n").replace("#", "\n"),
					(ent.@say4.toString() as String).replace("#", "\n").replace("#", "\n").replace("#", "\n"),
					(ent.@say5.toString() as String).replace("#", "\n").replace("#", "\n").replace("#", "\n")
					]));
				if (ent.name() == "McPixel")
					add(new McPixel(ent.@x, ent.@y, [
					(ent.@say1.toString() as String).replace("#", "\n").replace("#", "\n").replace("#", "\n"),
					(ent.@say2.toString() as String).replace("#", "\n").replace("#", "\n").replace("#", "\n"),
					(ent.@say3.toString() as String).replace("#", "\n").replace("#", "\n").replace("#", "\n"),
					(ent.@say4.toString() as String).replace("#", "\n").replace("#", "\n").replace("#", "\n"),
					(ent.@say5.toString() as String).replace("#", "\n").replace("#", "\n").replace("#", "\n")
					]));
			}
			
		}
		
		public function setText(t:String):void
		{
			if (t == "FUCKTHEPOPO")
			{
				FP.screen.color = 0x000000;
				FP.world = new End();
			}
			currentTalking = t;
			messageText.text = t;
		}
		
		public function setTalkingEntity(e:Entity):void
		{
			talkingEntity = e;
		}
	
		public function getTalkingEntity():Entity
		{
			return talkingEntity;
		}

		override public function update():void
		{
			super.update();
			if (myHector != null)
			{
			FP.camera.x = myHector.x + 24 - FP.screen.width / 2;
			if (leftDoor)
				if (myHector.x + 24 < leftDoor.x)
					FP.world = new TestWorld((leftDoor as Door).gotoString, (leftDoor as Door).gotoX);

			if (rightDoor)
				if (myHector.x + 24 > rightDoor.x + 16)
					FP.world = new TestWorld((rightDoor as Door).gotoString, (rightDoor as Door).gotoX);
			}
			if (FP.camera.x < 0)
				FP.camera.x = 0;
			if (FP.camera.x > levelWidth - FP.screen.width)
				FP.camera.x = levelWidth - FP.screen.width;
		}
		
		override public function render():void
		{
			super.render();
			if (currentTalking != "")
			{
				imgMessageBox.render(FP.buffer, FP.zero, FP.zero);
				FP.point.x = 8;
				FP.point.y = 4;
				messageText.render(FP.buffer, FP.point, FP.zero);
			}
		}
		
	}

}